/*----- PROTECTED REGION ID(AxisG2Selector.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2Selector.h
//
// description : Include file for the AxisG2Selector class
//
// project :     Selector Generation2
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// Author: abrami
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2Selector_H
#define AxisG2Selector_H

#include <tango.h>

        // MYCODE-START

#include "libaxisutils.h"
#include "AxisG2SelectorErrors.h"

#include "Types.h"
#include "Targets.h"

#include "FSM.h"
#include "TFSM.h"

#include <math.h>
#include "CombineState.h"

#ifdef HAVE_SAFETYMANAGER
	#include <SafetyManager.h>
#endif

#define DSTATUSMAX 128

#include "History.h"

#include "SeqMoveThreadErrors.h"


        // MYCODE-END


/*----- PROTECTED REGION END -----*/	//	AxisG2Selector.h

/**
 *  AxisG2Selector class description:
 *    
 */

namespace AxisG2Selector_ns
{
/*----- PROTECTED REGION ID(AxisG2Selector::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations
        class SeqMoveThread;

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::Additional Class Declarations

class AxisG2Selector : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(AxisG2Selector::Data Members) ENABLED START -----*/

friend class TrajectoryFSM;
friend class TFSM;

//	Add your own data members

        // MYCODE-START

        vector<sourceDev2_t> sources;
        vector<source_state_dval_t> sources_val;
	map<string, int>   nick2idx;

	vector<Target> trgs;
	vector<Target> utrgs;
	vector<Target> * trgs_in_use;
	Tango::AttrQuality attr_Instrument_Selector_quality;

	std::vector<string> DST;

	TrajectoryFSM * fsm;
	int Selector_new_val;

	TFSM * tfsm;

        #ifdef HAVE_SAFETYMANAGER
        	SafetyManager* safety_manger;
        	int _delay_safety_manger;
        #endif

        History_ns::history* hist;

        // MYCODE-END


/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::Data Members

//	Device property data members
public:
	//	AxisDevices:	nickName;tangoDevice;PositionAttribute;StopCmd;InitCmd[;timeOut]
	vector<string>	axisDevices;
	//	Targets:	una lista di
	//  TargetName;TargetStatus;nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta]
	//  
	//  la terna nickName:positionValue:positionDelta si ripete piu` volte,
	//  nickName non puo` essere ripetuto
	//  nickName deve essere presente in AxisDevices
	vector<string>	targets;
	//	Trajectories:	
	vector<string>	trajectories;
	//	SafetyRules:	
	vector<string>	safetyRules;
	//	DefaultState:	
	string	defaultState;
	//	NoTargetValue:	
	string	noTargetValue;
	//	FSMTransitionNoTargetEnable:	
	Tango::DevBoolean	fSMTransitionNoTargetEnable;
	//	FSMTransitionCommands:	
	vector<string>	fSMTransitionCommands;
	//	FSMTransitionOnMoving:	
	Tango::DevBoolean	fSMTransitionOnMoving;
	//	FSMTransitionEnable:	
	Tango::DevBoolean	fSMTransitionEnable;
	//	MovementCounter:	- ogni comando axis init incrementa di 2 unita` il movements_counter
	//  - ogni spostamento da una posizione (WM, PHOT,EBEAM, etc) ad un`altra posizione incrementa il movements_counter di 1 unita
	Tango::DevLong	movementCounter;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevString	*attr_Instrument_read;
	Tango::DevShort	*attr_Selector_read;
	Tango::DevUShort	*attr_DeviceState_read;
	Tango::DevString	*attr_DeviceStatus_read;
	Tango::DevULong	*attr_Updater_read;
	Tango::DevString	*attr_TrajectoryFSM_read;
	Tango::DevBoolean	*attr_UserConfig_read;
	Tango::DevString	*attr_ExtStatus_read;
	Tango::DevString	*attr_UserConfigData_read;
	Tango::DevString	*attr_History_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2Selector(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	AxisG2Selector(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	AxisG2Selector(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~AxisG2Selector() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : AxisG2Selector::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : AxisG2Selector::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Instrument related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Instrument(Tango::Attribute &attr);
	virtual void write_Instrument(Tango::WAttribute &attr);
	virtual bool is_Instrument_allowed(Tango::AttReqType type);
/**
 *	Attribute Selector related methods
 *	Description: 
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_Selector(Tango::Attribute &attr);
	virtual void write_Selector(Tango::WAttribute &attr);
	virtual bool is_Selector_allowed(Tango::AttReqType type);
/**
 *	Attribute DeviceState related methods
 *	Description: enum {
 *                	UNKNOWN,
 *               	ONLINE,
 *                	OFFLINE,
 *                	SERVICE,
 *                	TEST
 *                };
 *               Detto meccanismo permetterebbe al *responsabile del dispositivo* di
 *               ``metterlo`` fuori linea, in manutenzione, etc. etc.
 *
 *	Data type:	Tango::DevUShort
 *	Attr type:	Scalar
 */
	virtual void read_DeviceState(Tango::Attribute &attr);
	virtual void write_DeviceState(Tango::WAttribute &attr);
	virtual bool is_DeviceState_allowed(Tango::AttReqType type);
/**
 *	Attribute DeviceStatus related methods
 *	Description: enum {
 *                	UNKNOWN,
 *               	ONLINE,
 *                	OFFLINE,
 *                	SERVICE,
 *                	TEST
 *                };
 *               Detto meccanismo permetterebbe al *responsabile del dispositivo* di
 *               ``metterlo`` fuori linea, in manutenzione, etc. etc.
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_DeviceStatus(Tango::Attribute &attr);
	virtual bool is_DeviceStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute Updater related methods
 *	Description: 
 *
 *	Data type:	Tango::DevULong
 *	Attr type:	Scalar
 */
	virtual void read_Updater(Tango::Attribute &attr);
	virtual bool is_Updater_allowed(Tango::AttReqType type);
/**
 *	Attribute TrajectoryFSM related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_TrajectoryFSM(Tango::Attribute &attr);
	virtual bool is_TrajectoryFSM_allowed(Tango::AttReqType type);
/**
 *	Attribute UserConfig related methods
 *	Description: 
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_UserConfig(Tango::Attribute &attr);
	virtual void write_UserConfig(Tango::WAttribute &attr);
	virtual bool is_UserConfig_allowed(Tango::AttReqType type);
/**
 *	Attribute ExtStatus related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 100
 */
	virtual void read_ExtStatus(Tango::Attribute &attr);
	virtual bool is_ExtStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute UserConfigData related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 1000
 */
	virtual void read_UserConfigData(Tango::Attribute &attr);
	virtual void write_UserConfigData(Tango::WAttribute &attr);
	virtual bool is_UserConfigData_allowed(Tango::AttReqType type);
/**
 *	Attribute History related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 2000
 */
	virtual void read_History(Tango::Attribute &attr);
	virtual bool is_History_allowed(Tango::AttReqType type);

//	Dynamic attribute methods
public:

	/**
	 *	Attribute Position related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_Position(Tango::Attribute &attr);
	virtual void write_Position(Tango::WAttribute &attr);
	virtual bool is_Position_allowed(Tango::AttReqType type);
	void add_Position_dynamic_attribute(string attname);
	void remove_Position_dynamic_attribute(string attname);
	Tango::DevDouble *get_Position_data_ptr(string &name);
	map<string,Tango::DevDouble>	   Position_data;

	/**
	 *	Attribute DeltaPosition related methods
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar
	 */
	virtual void read_DeltaPosition(Tango::Attribute &attr);
	virtual void write_DeltaPosition(Tango::WAttribute &attr);
	virtual bool is_DeltaPosition_allowed(Tango::AttReqType type);
	void add_DeltaPosition_dynamic_attribute(string attname);
	void remove_DeltaPosition_dynamic_attribute(string attname);
	Tango::DevDouble *get_DeltaPosition_data_ptr(string &name);
	map<string,Tango::DevDouble>	   DeltaPosition_data;

	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2Selector::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command GetInstrumentList related method
	 *	Description: 
	 *
	 *	@returns 
	 */
	virtual Tango::DevVarStringArray *get_instrument_list();
	virtual bool is_GetInstrumentList_allowed(const CORBA::Any &any);
	/**
	 *	Command AxisInit related method
	 *	Description: 
	 *
	 */
	virtual void axis_init();
	virtual bool is_AxisInit_allowed(const CORBA::Any &any);
	/**
	 *	Command Stop related method
	 *	Description: 
	 *
	 */
	virtual void stop();
	virtual bool is_Stop_allowed(const CORBA::Any &any);
	/**
	 *	Command Save related method
	 *	Description: Save current position on current user target
	 *
	 *	@returns 
	 */
	virtual Tango::DevString save();
	virtual bool is_Save_allowed(const CORBA::Any &any);
	/**
	 *	Command GetTPos related method
	 *	Description: GetTPos(selector,attribute)
	 *               return target_position,delta
	 *
	 *	@param argin 
	 *	@returns 
	 */
	virtual Tango::DevVarDoubleArray *get_tpos(const Tango::DevVarLongStringArray *argin);
	virtual bool is_GetTPos_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : AxisG2Selector::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(AxisG2Selector::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

	bool parseSources(vector<string>& axisDevices,  vector<sourceDev2_t>& sources);

	bool parseTargets(vector<string>& targets,  vector<Target>& trgs);
	bool checkTargets(vector<Target>& trgs, string &msg);

	bool sourcesAxisInit(TrajectoryMode_t mode, string &err);
	bool sourcesStopAll();
	string sourcesIdx2Name(int index);

	void exit_on_fault() {
		if ( get_state () == Tango::FAULT ){
			string	status(get_status());
			Tango::Except::throw_exception(
					(const char *)"SERVER FAULT",
					status.c_str(),
					(const char *)"AxisG2Selector()");
		}
	};

        void ExtStatus(Tango::DevString *extstatusattr, int *riga, string msg);

	vector<string> getUserConfigData(const Tango::ConstDevString *w_val, int w_length);
	bool Targets2Config(vector<Target>& trgs, vector<string>& targets);

protected:
	void inc_move_counter(int k);

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::Additional Method prototypes
};

/*----- PROTECTED REGION ID(AxisG2Selector::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::Additional Classes Definitions

}	//	End of namespace

#endif   //	AxisG2Selector_H
