/*----- PROTECTED REGION ID(AxisG2SelectorClass.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2SelectorClass.cpp
//
// description : C++ source for the AxisG2SelectorClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the AxisG2Selector once per process.
//
// project :     Selector Generation2
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// Author: abrami 
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2SelectorClass.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass.cpp

//-------------------------------------------------------------------
/**
 *	Create AxisG2SelectorClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_AxisG2Selector_class(const char *name) {
		return AxisG2Selector_ns::AxisG2SelectorClass::init(name);
	}
}

namespace AxisG2Selector_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
AxisG2SelectorClass *AxisG2SelectorClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		AxisG2SelectorClass::AxisG2SelectorClass(string &s)
 * description : 	constructor for the AxisG2SelectorClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
AxisG2SelectorClass::AxisG2SelectorClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering AxisG2SelectorClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(AxisG2SelectorClass::constructor) ENABLED START -----*/

        // version tag

        string Release(RELEASE);
        set_cvs_tag(Release);

        string Repository(REPO);
        set_cvs_location(Repository);

        doc_url = REPO;
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::constructor

	cout2 << "Leaving AxisG2SelectorClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2SelectorClass::~AxisG2SelectorClass()
 * description : 	destructor for the AxisG2SelectorClass
 */
//--------------------------------------------------------
AxisG2SelectorClass::~AxisG2SelectorClass()
{
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		AxisG2SelectorClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
AxisG2SelectorClass *AxisG2SelectorClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new AxisG2SelectorClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		AxisG2SelectorClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
AxisG2SelectorClass *AxisG2SelectorClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		GetInstrumentListClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetInstrumentListClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "GetInstrumentListClass::execute(): arrived" << endl;
	return insert((static_cast<AxisG2Selector *>(device))->get_instrument_list());
}

//--------------------------------------------------------
/**
 * method : 		AxisInitClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *AxisInitClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "AxisInitClass::execute(): arrived" << endl;
	((static_cast<AxisG2Selector *>(device))->axis_init());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		StopClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *StopClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "StopClass::execute(): arrived" << endl;
	((static_cast<AxisG2Selector *>(device))->stop());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SaveClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SaveClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "SaveClass::execute(): arrived" << endl;
	return insert((static_cast<AxisG2Selector *>(device))->save());
}

//--------------------------------------------------------
/**
 * method : 		GetTPosClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *GetTPosClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	cout2 << "GetTPosClass::execute(): arrived" << endl;
	const Tango::DevVarLongStringArray *argin;
	extract(in_any, argin);
	return insert((static_cast<AxisG2Selector *>(device))->get_tpos(argin));
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2SelectorClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2SelectorClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum AxisG2SelectorClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void AxisG2SelectorClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "AxisDevices";
	prop_desc = "nickName;tangoDevice;PositionAttribute;StopCmd;InitCmd[;timeOut]";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Targets";
	prop_desc = "una lista di\nTargetName;TargetStatus;nickName:positionValue:positionDelta[;nickName:positionValue:positionDelta]\n\nla terna nickName:positionValue:positionDelta si ripete piu` volte,\nnickName non puo` essere ripetuto\nnickName deve essere presente in AxisDevices";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Trajectories";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "SafetyRules";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "DefaultState";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "NoTargetValue";
	prop_desc = "";
	prop_def  = "NO Target";
	vect_data.clear();
	vect_data.push_back("NO Target");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "FSMTransitionNoTargetEnable";
	prop_desc = "";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "FSMTransitionCommands";
	prop_desc = "";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "FSMTransitionOnMoving";
	prop_desc = "";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "FSMTransitionEnable";
	prop_desc = "";
	prop_def  = "false";
	vect_data.clear();
	vect_data.push_back("false");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "MovementCounter";
	prop_desc = "- ogni comando axis init incrementa di 2 unita` il movements_counter\n- ogni spostamento da una posizione (WM, PHOT,EBEAM, etc) ad un`altra posizione incrementa il movements_counter di 1 unita";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void AxisG2SelectorClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Selector Generation2");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void AxisG2SelectorClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new AxisG2Selector(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		AxisG2Selector *dev = static_cast<AxisG2Selector *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(AxisG2SelectorClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void AxisG2SelectorClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::attribute_factory_before
	//	Attribute : Instrument
	InstrumentAttrib	*instrument = new InstrumentAttrib();
	Tango::UserDefaultAttrProp	instrument_prop;
	//	description	not set for Instrument
	//	label	not set for Instrument
	//	unit	not set for Instrument
	//	standard_unit	not set for Instrument
	//	display_unit	not set for Instrument
	//	format	not set for Instrument
	//	max_value	not set for Instrument
	//	min_value	not set for Instrument
	//	max_alarm	not set for Instrument
	//	min_alarm	not set for Instrument
	//	max_warning	not set for Instrument
	//	min_warning	not set for Instrument
	//	delta_t	not set for Instrument
	//	delta_val	not set for Instrument
	
	instrument->set_default_properties(instrument_prop);
	//	Not Polled
	instrument->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(instrument);

	//	Attribute : Selector
	SelectorAttrib	*selector = new SelectorAttrib();
	Tango::UserDefaultAttrProp	selector_prop;
	//	description	not set for Selector
	//	label	not set for Selector
	//	unit	not set for Selector
	//	standard_unit	not set for Selector
	//	display_unit	not set for Selector
	selector_prop.set_format("%02d");
	//	max_value	not set for Selector
	//	min_value	not set for Selector
	//	max_alarm	not set for Selector
	//	min_alarm	not set for Selector
	//	max_warning	not set for Selector
	//	min_warning	not set for Selector
	//	delta_t	not set for Selector
	//	delta_val	not set for Selector
	
	selector->set_default_properties(selector_prop);
	selector->set_polling_period(1000);
	selector->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(selector);

	//	Attribute : DeviceState
	DeviceStateAttrib	*devicestate = new DeviceStateAttrib();
	Tango::UserDefaultAttrProp	devicestate_prop;
	devicestate_prop.set_description("enum {\n 	UNKNOWN,\n	ONLINE,\n 	OFFLINE,\n 	SERVICE,\n 	TEST\n };\nDetto meccanismo permetterebbe al *responsabile del dispositivo* di\n``metterlo`` fuori linea, in manutenzione, etc. etc.");
	devicestate_prop.set_label("Device State");
	devicestate_prop.set_unit("-");
	devicestate_prop.set_standard_unit("-");
	devicestate_prop.set_display_unit("-");
	devicestate_prop.set_format("%02d");
	devicestate_prop.set_max_value("4");
	devicestate_prop.set_min_value("0");
	//	max_alarm	not set for DeviceState
	//	min_alarm	not set for DeviceState
	//	max_warning	not set for DeviceState
	//	min_warning	not set for DeviceState
	//	delta_t	not set for DeviceState
	//	delta_val	not set for DeviceState
	
	devicestate->set_default_properties(devicestate_prop);
	//	Not Polled
	devicestate->set_disp_level(Tango::OPERATOR);
	devicestate->set_memorized();
	devicestate->set_memorized_init(true);
	att_list.push_back(devicestate);

	//	Attribute : DeviceStatus
	DeviceStatusAttrib	*devicestatus = new DeviceStatusAttrib();
	Tango::UserDefaultAttrProp	devicestatus_prop;
	devicestatus_prop.set_description("enum {\n 	UNKNOWN,\n	ONLINE,\n 	OFFLINE,\n 	SERVICE,\n 	TEST\n };\nDetto meccanismo permetterebbe al *responsabile del dispositivo* di\n``metterlo`` fuori linea, in manutenzione, etc. etc.");
	devicestatus_prop.set_label("Device Status");
	devicestatus_prop.set_unit("-");
	devicestatus_prop.set_standard_unit("-");
	devicestatus_prop.set_display_unit("-");
	devicestatus_prop.set_format("%s");
	//	max_value	not set for DeviceStatus
	//	min_value	not set for DeviceStatus
	//	max_alarm	not set for DeviceStatus
	//	min_alarm	not set for DeviceStatus
	//	max_warning	not set for DeviceStatus
	//	min_warning	not set for DeviceStatus
	//	delta_t	not set for DeviceStatus
	//	delta_val	not set for DeviceStatus
	
	devicestatus->set_default_properties(devicestatus_prop);
	//	Not Polled
	devicestatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(devicestatus);

	//	Attribute : Updater
	UpdaterAttrib	*updater = new UpdaterAttrib();
	Tango::UserDefaultAttrProp	updater_prop;
	//	description	not set for Updater
	updater_prop.set_label("Updater");
	updater_prop.set_unit("-");
	updater_prop.set_standard_unit("-");
	updater_prop.set_display_unit("-");
	updater_prop.set_format("%d");
	//	max_value	not set for Updater
	//	min_value	not set for Updater
	//	max_alarm	not set for Updater
	//	min_alarm	not set for Updater
	//	max_warning	not set for Updater
	//	min_warning	not set for Updater
	//	delta_t	not set for Updater
	//	delta_val	not set for Updater
	
	updater->set_default_properties(updater_prop);
	updater->set_polling_period(1000);
	updater->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(updater);

	//	Attribute : TrajectoryFSM
	TrajectoryFSMAttrib	*trajectoryfsm = new TrajectoryFSMAttrib();
	Tango::UserDefaultAttrProp	trajectoryfsm_prop;
	//	description	not set for TrajectoryFSM
	//	label	not set for TrajectoryFSM
	//	unit	not set for TrajectoryFSM
	//	standard_unit	not set for TrajectoryFSM
	//	display_unit	not set for TrajectoryFSM
	//	format	not set for TrajectoryFSM
	//	max_value	not set for TrajectoryFSM
	//	min_value	not set for TrajectoryFSM
	//	max_alarm	not set for TrajectoryFSM
	//	min_alarm	not set for TrajectoryFSM
	//	max_warning	not set for TrajectoryFSM
	//	min_warning	not set for TrajectoryFSM
	//	delta_t	not set for TrajectoryFSM
	//	delta_val	not set for TrajectoryFSM
	
	trajectoryfsm->set_default_properties(trajectoryfsm_prop);
	trajectoryfsm->set_polling_period(250);
	trajectoryfsm->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(trajectoryfsm);

	//	Attribute : UserConfig
	UserConfigAttrib	*userconfig = new UserConfigAttrib();
	Tango::UserDefaultAttrProp	userconfig_prop;
	//	description	not set for UserConfig
	//	label	not set for UserConfig
	//	unit	not set for UserConfig
	//	standard_unit	not set for UserConfig
	//	display_unit	not set for UserConfig
	//	format	not set for UserConfig
	//	max_value	not set for UserConfig
	//	min_value	not set for UserConfig
	//	max_alarm	not set for UserConfig
	//	min_alarm	not set for UserConfig
	//	max_warning	not set for UserConfig
	//	min_warning	not set for UserConfig
	//	delta_t	not set for UserConfig
	//	delta_val	not set for UserConfig
	
	userconfig->set_default_properties(userconfig_prop);
	//	Not Polled
	userconfig->set_disp_level(Tango::EXPERT);
	userconfig->set_memorized();
	userconfig->set_memorized_init(true);
	att_list.push_back(userconfig);

	//	Attribute : ExtStatus
	ExtStatusAttrib	*extstatus = new ExtStatusAttrib();
	Tango::UserDefaultAttrProp	extstatus_prop;
	//	description	not set for ExtStatus
	//	label	not set for ExtStatus
	//	unit	not set for ExtStatus
	//	standard_unit	not set for ExtStatus
	//	display_unit	not set for ExtStatus
	//	format	not set for ExtStatus
	//	max_value	not set for ExtStatus
	//	min_value	not set for ExtStatus
	//	max_alarm	not set for ExtStatus
	//	min_alarm	not set for ExtStatus
	//	max_warning	not set for ExtStatus
	//	min_warning	not set for ExtStatus
	//	delta_t	not set for ExtStatus
	//	delta_val	not set for ExtStatus
	
	extstatus->set_default_properties(extstatus_prop);
	//	Not Polled
	extstatus->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(extstatus);

	//	Attribute : UserConfigData
	UserConfigDataAttrib	*userconfigdata = new UserConfigDataAttrib();
	Tango::UserDefaultAttrProp	userconfigdata_prop;
	//	description	not set for UserConfigData
	//	label	not set for UserConfigData
	//	unit	not set for UserConfigData
	//	standard_unit	not set for UserConfigData
	//	display_unit	not set for UserConfigData
	//	format	not set for UserConfigData
	//	max_value	not set for UserConfigData
	//	min_value	not set for UserConfigData
	//	max_alarm	not set for UserConfigData
	//	min_alarm	not set for UserConfigData
	//	max_warning	not set for UserConfigData
	//	min_warning	not set for UserConfigData
	//	delta_t	not set for UserConfigData
	//	delta_val	not set for UserConfigData
	
	userconfigdata->set_default_properties(userconfigdata_prop);
	//	Not Polled
	userconfigdata->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(userconfigdata);

	//	Attribute : History
	HistoryAttrib	*history = new HistoryAttrib();
	Tango::UserDefaultAttrProp	history_prop;
	//	description	not set for History
	//	label	not set for History
	//	unit	not set for History
	//	standard_unit	not set for History
	//	display_unit	not set for History
	//	format	not set for History
	//	max_value	not set for History
	//	min_value	not set for History
	//	max_alarm	not set for History
	//	min_alarm	not set for History
	//	max_warning	not set for History
	//	min_warning	not set for History
	//	delta_t	not set for History
	//	delta_val	not set for History
	
	history->set_default_properties(history_prop);
	//	Not Polled
	history->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(history);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void AxisG2SelectorClass::pipe_factory()
{
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::pipe_factory_before
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void AxisG2SelectorClass::command_factory()
{
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::command_factory_before


	//	Command GetInstrumentList
	GetInstrumentListClass	*pGetInstrumentListCmd =
		new GetInstrumentListClass("GetInstrumentList",
			Tango::DEV_VOID, Tango::DEVVAR_STRINGARRAY,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pGetInstrumentListCmd);

	//	Command AxisInit
	AxisInitClass	*pAxisInitCmd =
		new AxisInitClass("AxisInit",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pAxisInitCmd);

	//	Command Stop
	StopClass	*pStopCmd =
		new StopClass("Stop",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pStopCmd);

	//	Command Save
	SaveClass	*pSaveCmd =
		new SaveClass("Save",
			Tango::DEV_VOID, Tango::DEV_STRING,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pSaveCmd);

	//	Command GetTPos
	GetTPosClass	*pGetTPosCmd =
		new GetTPosClass("GetTPos",
			Tango::DEVVAR_LONGSTRINGARRAY, Tango::DEVVAR_DOUBLEARRAY,
			"",
			"",
			Tango::EXPERT);
	command_list.push_back(pGetTPosCmd);

	/*----- PROTECTED REGION ID(AxisG2SelectorClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		AxisG2SelectorClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void AxisG2SelectorClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(AxisG2SelectorClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		AxisG2SelectorClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void AxisG2SelectorClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		AxisG2Selector *dev = static_cast<AxisG2Selector *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : AxisG2SelectorClass::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *AxisG2SelectorClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(AxisG2SelectorClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::Additional Methods
} //	namespace
