/*----- PROTECTED REGION ID(AxisG2SelectorClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2SelectorClass.h
//
// description : Include for the AxisG2Selector root class.
//               This class is the singleton class for
//                the AxisG2Selector device class.
//               It contains all properties and methods which the 
//               AxisG2Selector requires only once e.g. the commands.
//
// project :     Selector Generation2
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// Author: abrami
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef AxisG2SelectorClass_H
#define AxisG2SelectorClass_H

#include <tango.h>
#include <AxisG2Selector.h>


/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass.h


namespace AxisG2Selector_ns
{
/*----- PROTECTED REGION ID(AxisG2SelectorClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Instrument class definition
class InstrumentAttrib: public Tango::Attr
{
public:
	InstrumentAttrib():Attr("Instrument",
			Tango::DEV_STRING, Tango::READ_WRITE) {};
	~InstrumentAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_Instrument(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Selector *>(dev))->write_Instrument(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_Instrument_allowed(ty);}
};

//	Attribute Selector class definition
class SelectorAttrib: public Tango::Attr
{
public:
	SelectorAttrib():Attr("Selector",
			Tango::DEV_SHORT, Tango::READ_WRITE) {};
	~SelectorAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_Selector(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Selector *>(dev))->write_Selector(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_Selector_allowed(ty);}
};

//	Attribute DeviceState class definition
class DeviceStateAttrib: public Tango::Attr
{
public:
	DeviceStateAttrib():Attr("DeviceState",
			Tango::DEV_USHORT, Tango::READ_WRITE) {};
	~DeviceStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_DeviceState(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Selector *>(dev))->write_DeviceState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_DeviceState_allowed(ty);}
};

//	Attribute DeviceStatus class definition
class DeviceStatusAttrib: public Tango::Attr
{
public:
	DeviceStatusAttrib():Attr("DeviceStatus",
			Tango::DEV_STRING, Tango::READ) {};
	~DeviceStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_DeviceStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_DeviceStatus_allowed(ty);}
};

//	Attribute Updater class definition
class UpdaterAttrib: public Tango::Attr
{
public:
	UpdaterAttrib():Attr("Updater",
			Tango::DEV_ULONG, Tango::READ) {};
	~UpdaterAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_Updater(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_Updater_allowed(ty);}
};

//	Attribute TrajectoryFSM class definition
class TrajectoryFSMAttrib: public Tango::Attr
{
public:
	TrajectoryFSMAttrib():Attr("TrajectoryFSM",
			Tango::DEV_STRING, Tango::READ) {};
	~TrajectoryFSMAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_TrajectoryFSM(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_TrajectoryFSM_allowed(ty);}
};

//	Attribute UserConfig class definition
class UserConfigAttrib: public Tango::Attr
{
public:
	UserConfigAttrib():Attr("UserConfig",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~UserConfigAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_UserConfig(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Selector *>(dev))->write_UserConfig(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_UserConfig_allowed(ty);}
};

//	Attribute ExtStatus class definition
class ExtStatusAttrib: public Tango::SpectrumAttr
{
public:
	ExtStatusAttrib():SpectrumAttr("ExtStatus",
			Tango::DEV_STRING, Tango::READ, 100) {};
	~ExtStatusAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_ExtStatus(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_ExtStatus_allowed(ty);}
};

//	Attribute UserConfigData class definition
class UserConfigDataAttrib: public Tango::SpectrumAttr
{
public:
	UserConfigDataAttrib():SpectrumAttr("UserConfigData",
			Tango::DEV_STRING, Tango::READ_WRITE, 1000) {};
	~UserConfigDataAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_UserConfigData(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Selector *>(dev))->write_UserConfigData(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_UserConfigData_allowed(ty);}
};

//	Attribute History class definition
class HistoryAttrib: public Tango::SpectrumAttr
{
public:
	HistoryAttrib():SpectrumAttr("History",
			Tango::DEV_STRING, Tango::READ, 2000) {};
	~HistoryAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_History(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_History_allowed(ty);}
};


//=========================================
//	Define classes for dynamic attributes
//=========================================
//	Attribute Position class definition
class PositionAttrib: public Tango::Attr
{
public:
	PositionAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~PositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_Position(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Selector *>(dev))->write_Position(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_Position_allowed(ty);}
};

//	Attribute DeltaPosition class definition
class DeltaPositionAttrib: public Tango::Attr
{
public:
	DeltaPositionAttrib(const string &att_name):Attr(att_name.c_str(), 
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~DeltaPositionAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<AxisG2Selector *>(dev))->read_DeltaPosition(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<AxisG2Selector *>(dev))->write_DeltaPosition(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<AxisG2Selector *>(dev))->is_DeltaPosition_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command GetInstrumentList class definition
class GetInstrumentListClass : public Tango::Command
{
public:
	GetInstrumentListClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetInstrumentListClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetInstrumentListClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Selector *>(dev))->is_GetInstrumentList_allowed(any);}
};

//	Command AxisInit class definition
class AxisInitClass : public Tango::Command
{
public:
	AxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	AxisInitClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~AxisInitClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Selector *>(dev))->is_AxisInit_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~StopClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Selector *>(dev))->is_Stop_allowed(any);}
};

//	Command Save class definition
class SaveClass : public Tango::Command
{
public:
	SaveClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	SaveClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~SaveClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Selector *>(dev))->is_Save_allowed(any);}
};

//	Command GetTPos class definition
class GetTPosClass : public Tango::Command
{
public:
	GetTPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(name,in,out,in_desc,out_desc, level)	{};

	GetTPosClass(const char   *name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(name,in,out)	{};
	~GetTPosClass() {};
	
	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<AxisG2Selector *>(dev))->is_GetTPos_allowed(any);}
};


/**
 *	The AxisG2SelectorClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  AxisG2SelectorClass : public Tango::DeviceClass
#else
class AxisG2SelectorClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(AxisG2SelectorClass::Additionnal DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2SelectorClass::Additionnal DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
	
		//	Method prototypes
		static AxisG2SelectorClass *init(const char *);
		static AxisG2SelectorClass *instance();
		~AxisG2SelectorClass();
		Tango::DbDatum	get_class_property(string &);
		Tango::DbDatum	get_default_device_property(string &);
		Tango::DbDatum	get_default_class_property(string &);
	
	protected:
		AxisG2SelectorClass(string &);
		static AxisG2SelectorClass *_instance;
		void command_factory();
		void attribute_factory(vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		string get_cvstag();
		string get_cvsroot();
	
	private:
		void device_factory(const Tango::DevVarStringArray *);
		void create_static_attribute_list(vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,vector<Tango::Attr *> &);
		vector<string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname);
};

}	//	End of namespace

#endif   //	AxisG2Selector_H
