/*----- PROTECTED REGION ID(AxisG2Selector::DynAttrUtils.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        AxisG2SelectorDynAttrUtils.cpp
//
// description : Dynamic attributes utilities file for the AxisG2Selector class
//
// project :     Selector Generation2
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// Author: abrami
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <AxisG2Selector.h>
#include <AxisG2SelectorClass.h>

/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::DynAttrUtils.cpp

//================================================================
//  Attributes managed are:
//================================================================
//  Position       |  Tango::DevDouble	Scalar
//  DeltaPosition  |  Tango::DevDouble	Scalar
//================================================================

//	For compatibility reason, this file (AxisG2SelectorDynAttrUtils)
//	manage also the dynamic command utilities.
//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name  |  Method name
//================================================================
//================================================================

namespace AxisG2Selector_ns
{
//=============================================================
//	Add/Remove dynamic attribute methods
//=============================================================

//--------------------------------------------------------
/**
 *	Add a Position dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void AxisG2Selector::add_Position_dynamic_attribute(string attname)
{
	//	Attribute : Position
	PositionAttrib	*position = new PositionAttrib(attname);
	Tango::UserDefaultAttrProp	position_prop;
	//	description	not set for Position
	position_prop.set_label("Position");
	//	unit	not set for Position
	//	standard_unit	not set for Position
	//	display_unit	not set for Position
	//	format	not set for Position
	//	max_value	not set for Position
	//	min_value	not set for Position
	//	max_alarm	not set for Position
	//	min_alarm	not set for Position
	//	max_warning	not set for Position
	//	min_warning	not set for Position
	//	delta_t	not set for Position
	//	delta_val	not set for Position
	
	/*----- PROTECTED REGION ID(AxisG2Selector::att_Position_dynamic_attribute) ENABLED START -----*/
	position_prop.set_label(attname.c_str());
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::att_Position_dynamic_attribute
	position->set_default_properties(position_prop);
	//	Not Polled
	position->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	Position_data.insert(make_pair(attname, 0.0));
	add_attribute(position);
}
//--------------------------------------------------------
/**
 *	remove a Position dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void AxisG2Selector::remove_Position_dynamic_attribute(string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=Position_data.find(attname))!=Position_data.end())
    {
    	/*----- PROTECTED REGION ID(AxisG2Selector::remove_Position_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::remove_Position_dynamic_attribute
		Position_data.erase(ite);
	}
}
//--------------------------------------------------------
/**
 *	Add a DeltaPosition dynamic attribute.
 *
 *  parameter attname: attribute name to be cretated and added.
 */
//--------------------------------------------------------
void AxisG2Selector::add_DeltaPosition_dynamic_attribute(string attname)
{
	//	Attribute : DeltaPosition
	DeltaPositionAttrib	*deltaposition = new DeltaPositionAttrib(attname);
	Tango::UserDefaultAttrProp	deltaposition_prop;
	//	description	not set for DeltaPosition
	deltaposition_prop.set_label("DeltaPosition");
	//	unit	not set for DeltaPosition
	//	standard_unit	not set for DeltaPosition
	//	display_unit	not set for DeltaPosition
	//	format	not set for DeltaPosition
	//	max_value	not set for DeltaPosition
	//	min_value	not set for DeltaPosition
	//	max_alarm	not set for DeltaPosition
	//	min_alarm	not set for DeltaPosition
	//	max_warning	not set for DeltaPosition
	//	min_warning	not set for DeltaPosition
	//	delta_t	not set for DeltaPosition
	//	delta_val	not set for DeltaPosition
	
	/*----- PROTECTED REGION ID(AxisG2Selector::att_DeltaPosition_dynamic_attribute) ENABLED START -----*/
	deltaposition_prop.set_label(attname.c_str());
	
	
	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::att_DeltaPosition_dynamic_attribute
	deltaposition->set_default_properties(deltaposition_prop);
	//	Not Polled
	deltaposition->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	DeltaPosition_data.insert(make_pair(attname, 0.0));
	add_attribute(deltaposition);
}
//--------------------------------------------------------
/**
 *	remove a DeltaPosition dynamic attribute.
 *
 *  parameter attname: attribute name to be removed.
 */
//--------------------------------------------------------
void AxisG2Selector::remove_DeltaPosition_dynamic_attribute(string attname)
{
	remove_attribute(attname, true, Tango::Util::instance()->_UseDb);
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=DeltaPosition_data.find(attname))!=DeltaPosition_data.end())
    {
    	/*----- PROTECTED REGION ID(AxisG2Selector::remove_DeltaPosition_dynamic_attribute) ENABLED START -----*/
    	
    	/*----- PROTECTED REGION END -----*/	//	AxisG2Selector::remove_DeltaPosition_dynamic_attribute
		DeltaPosition_data.erase(ite);
	}
}


//============================================================
//	Tool methods to get pointer on attribute data buffer 
//============================================================
//--------------------------------------------------------
/**
 *	Return a pointer on Position data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *AxisG2Selector::get_Position_data_ptr(string &name)
{
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=Position_data.find(name))==Position_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"AxisG2Selector::get_Position_data_ptr()");
    }
	return  &(ite->second);
}
//--------------------------------------------------------
/**
 *	Return a pointer on DeltaPosition data.
 *
 *  parameter attname: the specified attribute name.
 */
//--------------------------------------------------------
Tango::DevDouble *AxisG2Selector::get_DeltaPosition_data_ptr(string &name)
{
	map<string,Tango::DevDouble>::iterator ite;
    if ((ite=DeltaPosition_data.find(name))==DeltaPosition_data.end())
    {
		TangoSys_OMemStream	tms;
		tms << "Dynamic attribute " << name << " has not been created";
		Tango::Except::throw_exception(
					(const char *)"ATTRIBUTE_NOT_FOUND",
					tms.str().c_str(),
					(const char *)"AxisG2Selector::get_DeltaPosition_data_ptr()");
    }
	return  &(ite->second);
}


//=============================================================
//	Add/Remove dynamic command methods
//=============================================================


} //	namespace
