#ifndef AXISG2SELECTORERRORS_H_
#define AXISG2SELECTORERRORS_H_

namespace AxisG2Selector_ns {

typedef enum {
        AG2S_E000,
        AG2S_E001,
        AG2S_E002,
	AG2S_E003,
	AG2S_E004,
	AG2S_E005,
	AG2S_E006,
	AG2S_E007,
	AG2S_E008,
	AG2S_E009,
	AG2S_E010,
	AG2S_E011,
	AG2S_E012
} AG2SError_t;


inline string  ag2s_error_str(AG2SError_t e){
        switch(e){
                case AG2S_E000: return "AG2S_E000: nickName already defined!"; break;
                case AG2S_E001: return "AG2S_E001: source badly defined"; break;
                case AG2S_E002: return "AG2S_E002: source not present in dB"; break;
                case AG2S_E003: return "AG2S_E003: unable to get data_type"; break;
                case AG2S_E004: return "AG2S_E004: unable to write to device"; break;
                case AG2S_E005: return "AG2S_E005: unknown source for target"; break;
                case AG2S_E007: return "AG2S_E007: error on axis stop!"; break;
                case AG2S_E008: return "AG2S_E008: error on axis init"; break;
                case AG2S_E009: return "AG2S_E009: error configuring Intrument property"; break;
                case AG2S_E010: return "AG2S_E010: error on read memorized attribute UserConfig->Targets"; break;
                case AG2S_E011: return "AG2S_E011: unknown source for user target"; break;
                case AG2S_E012: return "AG2S_E012: forbidden equal targets"; break;
                default:
                        {
                          std::stringstream ss;
                          ss << "-?- [AG2SError= " << e << " ]";
                          return ss.str();
                        }
                        break;
        }
        return "-?-";
}

} /* namespace */

#endif /* AXISG2SELECTORERRORS_H_ */
