#include "AxisG2Selector.h"


namespace AxisG2Selector_ns
{

void AxisG2Selector::inc_move_counter(int k) 
{
	#ifdef _PPC_PPC_
	  Tango::DevULong cur_move_counter;
	#else
	  int32_t cur_move_counter;
	#endif
	Tango::Database *db = new Tango::Database(); 	

	try {	
		Tango::DbData	get_move_counter;
		get_move_counter.push_back(Tango::DbDatum("MovementCounter"));
		get_db_device()->get_property(get_move_counter); 
		if (get_move_counter[0].is_empty()==false) {
			get_move_counter[0] >>  cur_move_counter;

			Tango::DbDatum set_move_counter("MovementCounter");
			Tango::DbData db_data;
			set_move_counter << (cur_move_counter + k);
			db_data.push_back(set_move_counter);

			db->put_device_property(get_name(), db_data);
		} else {
			// DO NOTHING
		} 
	}	

	catch(Tango::DevFailed e) {
		delete db;
		Tango::Except::throw_exception(
			(const char *)"Failed to movement counter",
			(const char *)"Can't save movement counter in database",
			(const char *)"AxisG2Selector::inc_move_counter()", Tango::ERR);	
	}

	catch (...) {
		delete db;
		Tango::Except::throw_exception(
			(const char *)"Failed to movement counter",
			(const char *)"Can't save movement counter in database",
			(const char *)"AxisG2Selector::inc_move_counter()", Tango::ERR);	
	}

	delete db;
}

} // namespace
