#include <AxisG2Selector.h>

#define STRINGSIZE 128



namespace AxisG2Selector_ns
{


bool AxisG2Selector::parseSources(vector<string>& axisDevices,  vector<sourceDev2_t>& sources){


	/************************
	*  AxisDevices [array of strings]: una lista di
	*	nickName;tangoDevice;PositionAttribute;StopCmd;InitCmd[;timeOut]
        *        ----[ vanno a sostituire gli n GalilX|Y|ZDevice ]----
	*  
	*  es.: X;pos/movers/x_mrc_pos.03      ..... timeout di default
	*  es.: X;pos/movers/x_mrc_pos.03;2000 ..... timeout di 2sec
	***************************/


	bool init_device_ok = true;

	#ifdef _DBG_PARSE_SOURCES
		cout << endl;
		cout << device_name << ":: AxisDevices dumping properties" << endl;
		vector<string>::iterator it;
		for (it=axisDevices.begin(); it < axisDevices.end(); it++){
			cout << "   ...   |" << distance(axisDevices.begin(), it) << "| = |" << *it << "|" << endl;
		}
		cout << endl;
		cout << endl;
	#endif /* _DBG_PARSE_SOURCES */

	vector<string> a;
        sourceDev2_t s;
	vector<sourceDev2_t>::iterator sit;

	int new_idx(0);

	#ifdef _DBG_PARSE_SOURCES
        	cout << device_name << ":: splitby(): -----------------" << endl;
	#endif /* _DBG_PARSE_SOURCES */

        for (size_t j=0; j<axisDevices.size(); j++ ){
		#ifdef _DBG_PARSE_SOURCES
                	cout << j << endl;
		#endif /* _DBG_PARSE_SOURCES */

		s.nickName = "";
		s.dev = "";
		s.attr = "";
		s.stopcmd = "";
		s.initcmd = "";
		s.tmo = 3000;
                a = splitby(axisDevices[j].c_str(), ';');
                if (a.size() >= 1 ) s.nickName = a[0];

		bool found = false;
		for (sit=sources.begin(); sit<sources.end() && !found; sit++){
			if ((*sit).nickName.compare(s.nickName) == 0){
				// gia' definito...
				found = true;
				string ss(ag2s_error_str(AG2S_E000));
				ss.append(" :|" + axisDevices[j] +"|");
				cout << ss << endl;
        			append_status(ss, true);
				init_device_ok &= false;
			} else {
				#ifdef _DBG_PARSE_SOURCES
					cout << "nickName differ: " << (*sit).nickName << "|" << s.nickName << endl;
				#endif /* _DBG_PARSE_SOURCES */
			}
		}
		
		if (!found){
                	if (a.size() >= 2 ) s.dev = a[1];
                	if (a.size() >= 3 ) s.attr = a[2];
                	if (a.size() >= 4 ) s.stopcmd = a[3];
                	if (a.size() >= 5 ) s.initcmd = a[4];
                	if (a.size() >= 6 ) s.tmo = atoi(a[5].c_str());
                	if ( (a.size() >= 1) &&
			     (s.dev.size() != 0 ) &&
			     (s.attr.size() != 0 ) 
			   ) {
				#ifdef _DBG_PARSE_SOURCES
					cout << "insert:" << s.nickName << "|" << s.dev << "|" << s.attr << endl;
				#endif /* _DBG_PARSE_SOURCES */

				s.index = new_idx;
                        	sources.push_back(s);

				nick2idx[s.nickName] = new_idx;

				source_state_dval_t ssv;
				ssv.source_idx = new_idx;
				ssv.quality = Tango::ATTR_INVALID;
				sources_val.push_back(ssv);

				new_idx++;
                	} else {
				string ss(ag2s_error_str(AG2S_E001));
				ss.append(" :|" + axisDevices[j] +"|");
				cout << ss << endl;
        			append_status(ss, true);
				init_device_ok &= false;
			}
		} 
		#ifdef _DBG_PARSE_SOURCES
			cout << endl;
		#endif /* _DBG_PARSE_SOURCES */
        }


	#ifdef _DBG_PARSE_SOURCES
		cout << endl;
		cout << "DUMPING sources: " << endl;
		for (sit=sources.begin(); sit<sources.end(); sit++){
			cout << "| nickName: " << (*sit).nickName << " | ";
			cout << "dev: " << (*sit).dev << " | ";
			cout << "attr: " << (*sit).attr << " | ";
			cout << "stopcmd: " << (*sit).stopcmd << " | ";
			cout << "initcmd: " << (*sit).initcmd << " | ";
			cout << "tmo: " << (*sit).tmo << " | ";
			cout << endl;
		}
		cout << endl;
	#endif /* _DBG_PARSE_SOURCES */

	return init_device_ok;

}
	
} //	namespace
