#include <cmath>
#include "SeqMoveThread.h"

#undef _FUNC

namespace AxisG2Selector_ns {

void SeqMoveThread::run(void *) {

        #ifdef _DBG_THREAD
                cout << "SeqMoveThread::run()" << endl;
        #endif

        _trgp->th_err.th_err = TH_RUNNING;

       	Tango::DeviceAttribute da;

        while (_go_on) {
        	#ifdef _DBG_THREAD
                	cout << "SeqMoveThread::while(" << (_go_on?"true":"false") << ")" << endl;
        	#endif

	        for (vector<target_source_t>::iterator tsit=_trgp->_trgSrcSeq.begin(); tsit != _trgp->_trgSrcSeq.end(); ++tsit){
	                if ( (_sources[(*tsit).source_idx].configured) ){
	                	Tango::DeviceAttribute da;
	                	double w_val = (*tsit).positionValue;

	                        #ifdef _DBG_PARSE_SEQ_TARGETS
	                                cout << "Target::go_seq(): SET " << _sources[(*tsit).source_idx].dev << " " << _sources[(*tsit).source_idx].attr << " = " << w_val << endl;
	                        #endif /* _DBG_PARSE_SEQ_TARGETS */

				// already on pos?
        			#ifdef _DBG_THREAD
					cout << " ----------------------- " << endl;
                        		cout << "source_idx:    " << (*tsit).source_idx << endl;
                        		cout << "positionValue: " << (*tsit).positionValue << endl;
                        		cout << "positionDelta: " << (*tsit).positionDelta << endl;
					cout << endl;
	                                cout << "source_idx:    " << _sources_val[(*tsit).source_idx].source_idx << endl;
	                                cout << "val:           " << _sources_val[(*tsit).source_idx].val << endl;
                		#endif /* _DBG_TARGET_UPDATE */

                                //if ( (*svit).quality == Tango::ATTR_INVALID ) ont=_on_target = false;

#if 1
				if ( fabs((*tsit).positionValue - (_sources_val[(*tsit).source_idx].val)) > (*tsit).positionDelta )  { 
		                        try {
		                                da.set_name(_sources[(*tsit).source_idx].attr);
		                                switch (_sources[(*tsit).source_idx].data_type){
		                                        case Tango::DEV_FLOAT:  break;
		                                        case Tango::DEV_DOUBLE: { double         double_val = (double)w_val;         da << double_val; }; break;
		                                        case Tango::DEV_LONG:   { Tango::DevLong   long_val = (Tango::DevLong)w_val; da << long_val; }; break;
		                                        case Tango::DEV_USHORT: { unsigned short     us_val = (unsigned short)w_val; da << us_val; }; break;
		                                        case Tango::DEV_SHORT:  { short           short_val = (short)w_val;          da << short_val; }; break;
		                                        default:                cout << "Not implemented attr_type= "<< Tango::CmdArgTypeName[_sources[(*tsit).source_idx].data_type];
		                                }
		                                _sources[(*tsit).source_idx].dp->write_attribute(da);
		                        } catch(...) {
		                                string ss(ag2s_error_str(AG2S_E004));
		                                ss.append(" : exception on Tango::DeviceProxy(" + _sources[(*tsit).source_idx].dev + ")!");
		                                cout << ss << endl;
		                                //append_status(ss, true);
		                        }
	
					// wait....
					#if 0
			                #ifdef _DBG_PARSE_SEQ_TARGETS
			                        cout << "Target::go_seq(): " << _sources[(*tsit).source_idx].dev << " ";
						cout << _sources[(*tsit).source_idx].dp->status() << " ... before sleep...."  << endl;
					#endif
		                	usleep(100*1000);
		                	while (_sources[(*tsit).source_idx].dp->state() == Tango::MOVING) {
						#if 1
			                        #ifdef _DBG_PARSE_SEQ_TARGETS
			                                cout << "Target::go_seq(): " << _sources[(*tsit).source_idx].dev << " ";
							cout << _sources[(*tsit).source_idx].dp->status() << " ... sleep...."  << endl;
			                        #endif /* _DBG_PARSE_SEQ_TARGETS */
						#endif
						usleep(10*1000);
					}
					#else
						do {
							while ( fabs((*tsit).positionValue - (_sources_val[(*tsit).source_idx].val)) > (*tsit).positionDelta ) {
        							#ifdef _DBG_THREAD
			                                		cout << "Target::go_seq():  while pos: ";
									cout << "fabs() =" <<  fabs((*tsit).positionValue - (_sources_val[(*tsit).source_idx].val)) << " ";
									cout << "delta =" << (*tsit).positionDelta;
									cout  << endl;
								#endif
								usleep(100*1000);
								update_pos((*tsit).source_idx);
							}
        						#ifdef _DBG_THREAD
			                               		cout << "Target::go_seq():  while MOVING" << endl;
							#endif
							usleep(100*1000);
						} while (_sources[(*tsit).source_idx].dp->state() == Tango::MOVING);
					#endif
				}
#else
	cout << "NO SEQ MOVE !!!" << endl;
#endif
	                } // if ( configured )
	        } // for ( _trgSrcSeq )

               	_trgp->th_err.th_err = TH_EXIT_OK;
		_go_on = false;
		exit();

        }; 
        _trgp->th_err.th_err = TH_FORCEDEXIT;
	_go_on = false;
}

void SeqMoveThread::update_pos(int tsit_source_idx){
	Tango::DeviceAttribute attr = _sources[tsit_source_idx].dp->read_attribute(_sources[tsit_source_idx].attr);

        switch (_sources[tsit_source_idx].data_type){
		case Tango::DEV_FLOAT:          float float_val;       attr >> float_val;  _sources_val[tsit_source_idx].val = (double)float_val ; break;
                case Tango::DEV_DOUBLE:         double double_val;     attr >> double_val; _sources_val[tsit_source_idx].val = (double)double_val; break;
                case Tango::DEV_LONG:           long long_val;         attr >> long_val;   _sources_val[tsit_source_idx].val = (double)long_val; break;
                case Tango::DEV_USHORT:         unsigned short us_val; attr >> us_val;     _sources_val[tsit_source_idx].val = (double)us_val; break;
                case Tango::DEV_SHORT:          short s_val; attr >> s_val;     	   _sources_val[tsit_source_idx].val = (double)s_val; break;
                case Tango::DATA_TYPE_UNKNOWN:
                	#if 0
                        	cout << "Unknown attr_type!" << endl;
                        #endif
                        Tango::Except::throw_exception(
                        	"Empty/UnknownDeviceAttribute",
                                "cannot extract, no data in DeviceAttribute object ",
                                "DeviceAttribute::is_empty"
                        );
                        break;
		default:
			{
                	if (_sources[tsit_source_idx].data_type <= Tango::DEVVAR_STATEARRAY)
                        	cout << "Not implemented attr_type= "<< Tango::CmdArgTypeName[_sources[tsit_source_idx].data_type] << endl;
                        else
                        	cout << "Unknown attr_type!" << endl;
                        throw;
                        };
                        break;
	}

}


} //namespace

