#ifndef SEQMOVETHREAD_H_
#define SEQMOVETHREAD_H_

#include <omnithread.h>
#include <tango.h>
#include <iostream>
#include "AxisG2Selector.h"

namespace AxisG2Selector_ns
{

class SeqMoveThread : public omni_thread {
public:
        SeqMoveThread(Target* trgp, vector<sourceDev2_t> &sources, vector<source_state_dval_t> &sources_val) :
                _trgp(trgp),
                _go_on(true),
		_sources(sources),
		_sources_val(sources_val)  {
	        #ifdef _DBG_THREAD
                	cout << "SeqMoveThread()"<< endl;
		#endif
        }
        virtual ~SeqMoveThread() {
	        #ifdef _DBG_THREAD
                	cout << "~SeqMoveThread()" << endl;
		#endif
        }

        void abort(void) { _go_on = false;}

protected:
        void run(void *);

	void update_pos(int tsit_source_idx);


private:
        Target* _trgp;
        bool _go_on;
	vector<sourceDev2_t> _sources;
	vector<source_state_dval_t> _sources_val;
};

}

#endif /* SEQMOVETHREAD_H_ */

