#include <AxisG2Selector.h>
#include <AxisG2SelectorClass.h>

#define STRINGSIZE 128


namespace AxisG2Selector_ns
{
/**
 *	Write attribute UserConfigData related method
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Spectrum max = 1000
 */
//--------------------------------------------------------
vector<string> AxisG2Selector::getUserConfigData(const Tango::ConstDevString *w_val, int w_length)
{
	DEBUG_STREAM << "AxisG2Selector::writeUserConfigData() entering... " << endl;
	vector<string> conf;
	stringstream trgt;
	
//AA
	#ifdef _DBG_UCDATA
		for (int i=0; i<w_length; i++){
			cout << "[" << i << "] " << w_val[i] << endl;
		}
		cout << endl;
	#endif
	
	int k = -1;
	string ins = "";
        vector<Target>::iterator it_trgs;
        for (it_trgs = utrgs.begin(); it_trgs != utrgs.end(); it_trgs++){

		trgt.str("");
                //":TARGET:"
		k++;
		ins = w_val[k];
		#ifdef _DBG_UCDATA
			cout << endl;
			cout << "[" << k << "] " << w_val[k] << " | " << ins << endl;
		#endif

		if (ins.compare(":TARGET:") != 0 ) {
			stringstream err("");
			err << "Error on line: " << k << " ";
			err << ":TARGET:";
			err << "|";
			err << ins;
			Tango::Except::throw_exception(
				(const char *) "Error 1",
				(const char *) err.str().c_str(),
				(const char *) "AxisG2Selector::getUserConfigData()");
		}

		k++;
		ins = w_val[k];
		#ifdef _DBG_UCDATA
			cout << "[" << k << "] " << w_val[k] << " | " << ins << endl;
		#endif
		if (ins.compare(it_trgs->name()) != 0 ) {
			stringstream err("");
			err << "Error on line: " << k << " ";
			err << it_trgs->name();
			err << "|";
			err << ins;
			Tango::Except::throw_exception(
				(const char *) "Error 2",
				(const char *) err.str().c_str(),
				(const char *) "AxisG2Selector::getUserConfigData()");
		} 
		trgt << ins << ";";
		

		k++;
		ins = w_val[k];
                //Tango::DevStateName[it_trgs->stateOnTarget()];
	        if ( (ins == "ON")  ||
	        	(ins == "OFF") ||
	        	(ins == "OPEN") ||
	        	(ins == "CLOSE") ||
	        	(ins == "INSERT") ||
	        	(ins == "EXTRACT") ||
	        	(ins == "STANDBY") ||
	        	(ins == "ALARM") ||
	       		(ins ==  "UNKNOWN")
		) {
		} else {
			stringstream err("");
			err << "Error on line: " << k << " ";
			err << "ON-OFF-OPEN-CLOSE-INSERT-EXTRACT-STANDBY-ALARM-UNKNOWN-";
			err << "|";
			err << ins;
			Tango::Except::throw_exception(
				(const char *) "Error 3",
				(const char *) err.str().c_str(),
				(const char *) "AxisG2Selector::getUserConfigData()");
		}
		trgt << ins;


                {
                	vector<target_source_t>::iterator it_src;
                        vector<target_source_t> trg_src = it_trgs->trg_src();
                        for (it_src = trg_src.begin(); it_src != trg_src.end(); it_src++){

				trgt << ";";
				k++;
				ins = w_val[k];
				#ifdef _DBG_UCDATA
					cout << "[" << k << "] " << w_val[k] << " | " << ins << endl;
				#endif
				if ( ins.compare(sourcesIdx2Name(it_src->source_idx)) != 0 ){
					stringstream err("");
					err << "Error on line: " << k << " ";
					err << sourcesIdx2Name(it_src->source_idx);
					err << "|";
					err << ins;
					Tango::Except::throw_exception(
						(const char *) "Error 4",
						(const char *) err.str().c_str(),
						(const char *) "AxisG2Selector::getUserConfigData()");
				}
				trgt << ins << ":";

				k++;
				ins = w_val[k];
				#ifdef _DBG_UCDATA
					cout << "positionValue " << ins << " ";
				#endif
                                //it_src->positionValue;
				trgt << ins << ":";
				#ifdef _DBG_UCDATA
					cout << "trg " << trgt.str() << endl;
				#endif

				k++;
				ins = w_val[k];
				#ifdef _DBG_UCDATA
					cout << "positionDelta " << ins << endl;
				#endif
				if ( atof(ins.c_str()) <= 0.0 ) {
					stringstream err("");
					err << "Error on line: " << k << " ";
					err << "delta > 0";
					err << "|";
					err << ins;
					Tango::Except::throw_exception(
						(const char *) "Error 5",
						(const char *) err.str().c_str(),
						(const char *) "AxisG2Selector::getUserConfigData()");
				}
				// it_src->positionDelta;
				trgt << ins;
				#ifdef _DBG_UCDATA
					cout << "trg " << trgt.str() << endl;
				#endif
                       }
			#ifdef _DBG_UCDATA
				cout << "trg " << trgt.str() << endl;
				cout << endl;
			#endif
                };
		conf.push_back(trgt.str());
	};
	// PARSING OK:

	#ifdef _DBG_UCDATA
	#endif
	
	return conf;
}

} //namespace
